package cn.dg32z.lon.checks.util.processor.tcprocessor;

import cn.dg32z.libs.chengzhiya.task.mhdfscheduler.scheduler.MHDFScheduler;
import cn.dg32z.libs.com.github.retrooper.packetevents.event.PacketReceiveEvent;
import cn.dg32z.lon.LonAntiCheat;
import cn.dg32z.lon.checks.Check;
import cn.dg32z.lon.checks.type.PacketCheck;
import cn.dg32z.lon.manager.plugin.init.HookInit;
import cn.dg32z.lon.player.PlayerData;
import cn.dg32z.network.TcpInfoRequest;
import cn.dg32z.network.util.TCPUtils;

/* loaded from: cn_dg32z_lon_checks_util_processor_tcprocessor.jar:cn/dg32z/lon/checks/util/processor/tcprocessor/TcpProcessor.class */
public class TcpProcessor extends Check implements PacketCheck {
    private int state;
    private int caState;
    private int retransmits;
    private int probes;
    private int backoff;
    private int options;
    private int sndWscale;
    private int rcvWscale;
    private long rto;
    private long ato;
    private long sndMss;
    private long rcvMss;
    private long unacked;
    private long sacked;
    private long lost;
    private long retrans;
    private long fackets;
    private long lastDataSent;
    private long lastAckSent;
    private long lastDataRecv;
    private long lastAckRecv;
    private long pmtu;
    private long rcvSsthresh;
    private long rtt;
    private long rttvar;
    private long sndSsthresh;
    private long sndCwnd;
    private long advmss;
    private long reordering;
    private long rcvRtt;
    private long rcvSpace;
    private long totalRetrans;
    private int highestRtt;
    private int lowestRtt;
    private int fixedRtt;
    private int smoothRtt;
    private int mathLost;
    private boolean realLost;
    private boolean isLagging;
    private boolean invalidPacketOrder;
    private boolean invalidRtt;
    private double[] minAndHigh;
    private StateType stateType;
    private long lastSend;

    /* loaded from: cn_dg32z_lon_checks_util_processor_tcprocessor.jar:cn/dg32z/lon/checks/util/processor/tcprocessor/TcpProcessor$StateType.class */
    public enum StateType {
        OPEN,
        CWR,
        RECOVERY,
        LOSS,
        UNKNOWN
    }

    public void setState(int state) {
        this.state = state;
    }

    public void setCaState(int caState) {
        this.caState = caState;
    }

    public void setRetransmits(int retransmits) {
        this.retransmits = retransmits;
    }

    public void setProbes(int probes) {
        this.probes = probes;
    }

    public void setBackoff(int backoff) {
        this.backoff = backoff;
    }

    public void setOptions(int options) {
        this.options = options;
    }

    public void setSndWscale(int sndWscale) {
        this.sndWscale = sndWscale;
    }

    public void setRcvWscale(int rcvWscale) {
        this.rcvWscale = rcvWscale;
    }

    public void setRto(long rto) {
        this.rto = rto;
    }

    public void setAto(long ato) {
        this.ato = ato;
    }

    public void setSndMss(long sndMss) {
        this.sndMss = sndMss;
    }

    public void setRcvMss(long rcvMss) {
        this.rcvMss = rcvMss;
    }

    public void setUnacked(long unacked) {
        this.unacked = unacked;
    }

    public void setSacked(long sacked) {
        this.sacked = sacked;
    }

    public void setLost(long lost) {
        this.lost = lost;
    }

    public void setRetrans(long retrans) {
        this.retrans = retrans;
    }

    public void setFackets(long fackets) {
        this.fackets = fackets;
    }

    public void setLastDataSent(long lastDataSent) {
        this.lastDataSent = lastDataSent;
    }

    public void setLastAckSent(long lastAckSent) {
        this.lastAckSent = lastAckSent;
    }

    public void setLastDataRecv(long lastDataRecv) {
        this.lastDataRecv = lastDataRecv;
    }

    public void setLastAckRecv(long lastAckRecv) {
        this.lastAckRecv = lastAckRecv;
    }

    public void setPmtu(long pmtu) {
        this.pmtu = pmtu;
    }

    public void setRcvSsthresh(long rcvSsthresh) {
        this.rcvSsthresh = rcvSsthresh;
    }

    public void setRtt(long rtt) {
        this.rtt = rtt;
    }

    public void setRttvar(long rttvar) {
        this.rttvar = rttvar;
    }

    public void setSndSsthresh(long sndSsthresh) {
        this.sndSsthresh = sndSsthresh;
    }

    public void setSndCwnd(long sndCwnd) {
        this.sndCwnd = sndCwnd;
    }

    public void setAdvmss(long advmss) {
        this.advmss = advmss;
    }

    public void setReordering(long reordering) {
        this.reordering = reordering;
    }

    public void setRcvRtt(long rcvRtt) {
        this.rcvRtt = rcvRtt;
    }

    public void setRcvSpace(long rcvSpace) {
        this.rcvSpace = rcvSpace;
    }

    public void setTotalRetrans(long totalRetrans) {
        this.totalRetrans = totalRetrans;
    }

    public void setHighestRtt(int highestRtt) {
        this.highestRtt = highestRtt;
    }

    public void setLowestRtt(int lowestRtt) {
        this.lowestRtt = lowestRtt;
    }

    public void setFixedRtt(int fixedRtt) {
        this.fixedRtt = fixedRtt;
    }

    public void setSmoothRtt(int smoothRtt) {
        this.smoothRtt = smoothRtt;
    }

    public void setMathLost(int mathLost) {
        this.mathLost = mathLost;
    }

    public void setRealLost(boolean realLost) {
        this.realLost = realLost;
    }

    public void setLagging(boolean isLagging) {
        this.isLagging = isLagging;
    }

    public void setInvalidPacketOrder(boolean invalidPacketOrder) {
        this.invalidPacketOrder = invalidPacketOrder;
    }

    public void setInvalidRtt(boolean invalidRtt) {
        this.invalidRtt = invalidRtt;
    }

    public void setMinAndHigh(double[] minAndHigh) {
        this.minAndHigh = minAndHigh;
    }

    public void setStateType(StateType stateType) {
        this.stateType = stateType;
    }

    public void setLastSend(long lastSend) {
        this.lastSend = lastSend;
    }

    public int getState() {
        return this.state;
    }

    public int getCaState() {
        return this.caState;
    }

    public int getRetransmits() {
        return this.retransmits;
    }

    public int getProbes() {
        return this.probes;
    }

    public int getBackoff() {
        return this.backoff;
    }

    public int getOptions() {
        return this.options;
    }

    public int getSndWscale() {
        return this.sndWscale;
    }

    public int getRcvWscale() {
        return this.rcvWscale;
    }

    public long getRto() {
        return this.rto;
    }

    public long getAto() {
        return this.ato;
    }

    public long getSndMss() {
        return this.sndMss;
    }

    public long getRcvMss() {
        return this.rcvMss;
    }

    public long getUnacked() {
        return this.unacked;
    }

    public long getSacked() {
        return this.sacked;
    }

    public long getLost() {
        return this.lost;
    }

    public long getRetrans() {
        return this.retrans;
    }

    public long getFackets() {
        return this.fackets;
    }

    public long getLastDataSent() {
        return this.lastDataSent;
    }

    public long getLastAckSent() {
        return this.lastAckSent;
    }

    public long getLastDataRecv() {
        return this.lastDataRecv;
    }

    public long getLastAckRecv() {
        return this.lastAckRecv;
    }

    public long getPmtu() {
        return this.pmtu;
    }

    public long getRcvSsthresh() {
        return this.rcvSsthresh;
    }

    public long getRtt() {
        return this.rtt;
    }

    public long getRttvar() {
        return this.rttvar;
    }

    public long getSndSsthresh() {
        return this.sndSsthresh;
    }

    public long getSndCwnd() {
        return this.sndCwnd;
    }

    public long getAdvmss() {
        return this.advmss;
    }

    public long getReordering() {
        return this.reordering;
    }

    public long getRcvRtt() {
        return this.rcvRtt;
    }

    public long getRcvSpace() {
        return this.rcvSpace;
    }

    public long getTotalRetrans() {
        return this.totalRetrans;
    }

    public int getHighestRtt() {
        return this.highestRtt;
    }

    public int getLowestRtt() {
        return this.lowestRtt;
    }

    public int getFixedRtt() {
        return this.fixedRtt;
    }

    public int getSmoothRtt() {
        return this.smoothRtt;
    }

    public int getMathLost() {
        return this.mathLost;
    }

    public boolean isRealLost() {
        return this.realLost;
    }

    public boolean isLagging() {
        return this.isLagging;
    }

    public boolean isInvalidPacketOrder() {
        return this.invalidPacketOrder;
    }

    public boolean isInvalidRtt() {
        return this.invalidRtt;
    }

    public double[] getMinAndHigh() {
        return this.minAndHigh;
    }

    public StateType getStateType() {
        return this.stateType;
    }

    public long getLastSend() {
        return this.lastSend;
    }

    public TcpProcessor(PlayerData player) {
        super(player);
        this.lastSend = 0L;
    }

    public void onPacketReceive(PacketReceiveEvent event) {
        if (!isTickPacket(event.getPacketType()) || time() - this.lastSend < 300) {
            return;
        }
        this.lastSend = time();
        if (!HookInit.getTcpInfoHook().isEnabled()) {
            return;
        }
        TcpInfoRequest.request(this.player.getBukkitPlayer(), info -> {
            MHDFScheduler.getAsyncScheduler().runTask(LonAntiCheat.getInstance(), task -> {
                StateType stateType;
                if (info == null) {
                    return;
                }
                setState(info.getState());
                setCaState(info.getCaState());
                setRetransmits(info.getRetransmits());
                setProbes(info.getProbes());
                setBackoff(info.getBackoff());
                setOptions(info.getOptions());
                setSndWscale(info.getSndWscale());
                setRcvWscale(info.getRcvWscale());
                setRto(info.getRto());
                setAto(info.getAto());
                setSndMss(info.getSndMss());
                setRcvMss(info.getRcvMss());
                setUnacked(info.getUnacked());
                setSacked(info.getSacked());
                setLost(info.getLost());
                setRetrans(info.getRetrans());
                setFackets(info.getFackets());
                setLastDataSent(info.getLastDataSent());
                setLastAckSent(info.getLastAckSent());
                setLastDataRecv(info.getLastAckRecv());
                setLastAckRecv(info.getLastAckRecv());
                setPmtu(info.getPmtu());
                setRcvSsthresh(info.getRcvSsthresh());
                setRtt(info.getRtt());
                setRttvar(info.getRttvar());
                setSndSsthresh(info.getSndSsthresh());
                setSndCwnd(info.getSndCwnd());
                setAdvmss(info.getAdvmss());
                setReordering(info.getReordering());
                setRcvRtt(info.getRcvRtt());
                setRcvSpace(info.getRcvSpace());
                setTotalRetrans(info.getRetrans());
                setFixedRtt(((int) TCPUtils.calcReliableRttMs(info)) + 15);
                switch (getCaState()) {
                    case 0:
                        stateType = StateType.OPEN;
                        break;
                    case 1:
                    case 2:
                        stateType = StateType.CWR;
                        break;
                    case 3:
                        stateType = StateType.RECOVERY;
                        break;
                    case 4:
                        stateType = StateType.LOSS;
                        break;
                    default:
                        stateType = StateType.UNKNOWN;
                        break;
                }
                setStateType(stateType);
                setInvalidPacketOrder(TCPUtils.isReorderingRisk(info, 3.0d));
                setMinAndHigh(TCPUtils.calcRttRangeMs(info));
                setRealLost(TCPUtils.isLossy(info, 0.08d));
                setMathLost((int) TCPUtils.calcLossRate(info));
                setHighestRtt((int) TCPUtils.getMaxPingMs(info));
                setLowestRtt((int) TCPUtils.getMinPingMs(info));
            });
        });
    }
}
